Botan 1.10.17

Public Member Functions | List of all members
Botan::Parallel Class Reference

`#include <par_hash.h>`

Inheritance diagram for Botan::Parallel:

## Public Member Functions
void | clear ()
HashFunction * | clone () const
void | final (byte out[])
SecureVector< byte > | final ()
virtual size_t | hash_block_size () const
std::string | name () const
size_t | output_length () const
| Parallel (const std::vector< HashFunction *> &hashes)
SecureVector< byte > | process (const byte in[], size_t length)
SecureVector< byte > | process (const MemoryRegion< byte > &in)
SecureVector< byte > | process (const std::string &in)
void | update (const byte in[], size_t length)
void | update (const MemoryRegion< byte > &in)
void | update (const std::string &str)
void | update (byte in)
template<typename T >
void | update_be (const T in)
| ~Parallel ()

## Detailed Description

Parallel Hashes

Definition at line 19 of file par_hash.h.

## Constructor & Destructor Documentation

## ◆ Parallel()

Botan::Parallel::Parallel | ( | const std::vector< HashFunction *> & | hashes | ) |

Parameters

  hashes | a set of hashes to compute in parallel

Definition at line 83 of file par_hash.cpp.

Referenced by clone().

83 :
84 hashes(hash_in)
85 {
86 }

## ◆ ~Parallel()

Botan::Parallel::~Parallel | ( |  | ) |

Definition at line 91 of file par_hash.cpp.

92 {
93 for(size_t i = 0; i != hashes.size(); ++i)
94 delete hashes[i];
95 }

## Member Function Documentation

## ◆ clear()

void Botan::Parallel::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 74 of file par_hash.cpp.

75 {
76 for(size_t i = 0; i != hashes.size(); ++i)
77 hashes[i]->clear();
78 }
Botan::Parallel::clear
void clear()
Definition: par_hash.cpp:74

## ◆ clone()

HashFunction * Botan::Parallel::clone | ( |  | ) | const
| virtual

Get a new object representing the same algorithm as *this

Implements Botan::HashFunction.

Definition at line 63 of file par_hash.cpp.

References Parallel().

64 {
65 std::vector<HashFunction*> hash_copies;
66 for(size_t i = 0; i != hashes.size(); ++i)
67 hash_copies.push_back(hashes[i]->clone());
68 return new Parallel(hash_copies);
69 }
Botan::Parallel::Parallel
Parallel(const std::vector< HashFunction *> &hashes)
Definition: par_hash.cpp:83

## ◆ final() [1/2]

void Botan::Buffered_Computation::final | ( | byte | out[] | ) |
| inline inherited

Complete the computation and retrieve the final result.

Parameters

  out | The byte array to be filled with the result. Must be of length output_length()

Definition at line 80 of file buf_comp.h.

Referenced by Botan::LubyRackoff::decrypt_n(), Botan::Lion::decrypt_n(), Botan::X942_PRF::derive(), Botan::KDF2::derive(), Botan::KDF1::derive(), Botan::PKCS5_PBKDF2::derive_key(), Botan::OpenPGP_S2K::derive_key(), Botan::PKCS5_PBKDF1::derive_key(), Botan::EMSA2::EMSA2(), Botan::LubyRackoff::encrypt_n(), Botan::Lion::encrypt_n(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::HandshakeHash::final(), Botan::HandshakeHash::final_ssl3(), Botan::Record_Reader::get_record(), Botan::MGF1::mask(), Botan::EMSA3::raw_data(), Botan::Randpool::reseed(), and Botan::HMAC_RNG::reseed().

80 { final_result(out); }

## ◆ final() [2/2]

SecureVector<byte> Botan::Buffered_Computation::final | ( |  | ) |
| inline inherited

Complete the computation and retrieve the final result.

Returns
  SecureVector holding the result

Definition at line 87 of file buf_comp.h.

88 {
89 SecureVector<byte> output(output_length());
90 final_result(&output[0]);
91 return output;
92 }
Botan::Buffered_Computation::output_length
virtual size_t output_length() const =0

## ◆ hash_block_size()

virtual size_t Botan::HashFunction::hash_block_size | ( |  | ) | const
| inline virtual inherited

The hash block size as defined for this algorithm

Reimplemented in Botan::MDx_HashFunction, Botan::Skein_512, Botan::Comb4P, Botan::Keccak_1600, Botan::GOST_34_11, and Botan::MD2.

Definition at line 32 of file hash.h.

Referenced by Botan::Comb4P::hash_block_size(), Botan::HMAC::HMAC(), and Botan::SSL3_MAC::SSL3_MAC().

32 { return 0; }

## ◆ name()

std::string Botan::Parallel::name | ( |  | ) | const
| virtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 48 of file par_hash.cpp.

49 {
50 std::string hash_names;
51 for(size_t i = 0; i != hashes.size(); ++i)
52 {
53 if(i)
54 hash_names += ',';
55 hash_names += hashes[i]->name();
56 }
57 return "Parallel(" + hash_names + ")";
58 }

## ◆ output_length()

size_t Botan::Parallel::output_length | ( |  | ) | const
| virtual

Returns
  length of the output of this function in bytes

Implements Botan::Buffered_Computation.

Definition at line 37 of file par_hash.cpp.

38 {
39 size_t sum = 0;
40 for(size_t i = 0; i != hashes.size(); ++i)
41 sum += hashes[i]->output_length();
42 return sum;
43 }
Botan::Parallel::output_length
size_t output_length() const
Definition: par_hash.cpp:37

## ◆ process() [1/3]

SecureVector<byte> Botan::Buffered_Computation::process | ( | const byte | in[],
|  | size_t | length
| ) |  |
| inline inherited

Update and finalize computation. Does the same as calling update() and final() consecutively.

Parameters

  in | the input to process as a byte array
  length | the length of the byte array

Returns
  the result of the call to final()

Definition at line 101 of file buf_comp.h.

Referenced by Botan::Randpool::add_entropy(), Botan::EME1::EME1(), and Botan::Cert_Extension::Subject_Key_ID::Subject_Key_ID().

102 {
103 add_data(in, length);
104 return final();
105 }

## ◆ process() [2/3]

SecureVector<byte> Botan::Buffered_Computation::process | ( | const MemoryRegion< byte > & | in | ) |
| inline inherited

Update and finalize computation. Does the same as calling update() and final() consecutively.

Parameters

  in | the input to process

Returns
  the result of the call to final()

Definition at line 113 of file buf_comp.h.

References Botan::MemoryRegion< T >::size().

114 {
115 add_data(&in[0], in.size());
116 return final();
117 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ process() [3/3]

SecureVector<byte> Botan::Buffered_Computation::process | ( | const std::string & | in | ) |
| inline inherited

Update and finalize computation. Does the same as calling update() and final() consecutively.

Parameters

  in | the input to process as a string

Returns
  the result of the call to final()

Definition at line 125 of file buf_comp.h.

126 {
127 update(in);
128 return final();
129 }
Botan::Buffered_Computation::update
void update(const byte in[], size_t length)
Definition: buf_comp.h:33

## ◆ update() [1/4]

void Botan::Buffered_Computation::update | ( | const byte | in[],
|  | size_t | length
| ) |  |
| inline inherited

Add new input to process.

Parameters

  in | the input to process as a byte array
  length | of param in in bytes

Definition at line 33 of file buf_comp.h.

Referenced by Botan::HMAC_RNG::add_entropy(), Botan::Comb4P::clear(), Botan::LubyRackoff::decrypt_n(), Botan::Lion::decrypt_n(), Botan::X942_PRF::derive(), Botan::KDF2::derive(), Botan::KDF1::derive(), Botan::PKCS5_PBKDF2::derive_key(), Botan::OpenPGP_S2K::derive_key(), Botan::PKCS5_PBKDF1::derive_key(), Botan::LubyRackoff::encrypt_n(), Botan::Lion::encrypt_n(), Botan::HandshakeHash::final(), Botan::HandshakeHash::final_ssl3(), Botan::Record_Reader::get_record(), Botan::MGF1::mask(), Botan::HMAC_RNG::reseed(), Botan::EAX_Base::start_msg(), and Botan::EMSA3::update().

33 { add_data(in, length); }

## ◆ update() [2/4]

void Botan::Buffered_Computation::update | ( | const MemoryRegion< byte > & | in | ) |
| inline inherited

Add new input to process.

Parameters

  in | the input to process as a MemoryRegion

Definition at line 39 of file buf_comp.h.

References Botan::MemoryRegion< T >::size().

40 {
41 add_data(&in[0], in.size());
42 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ update() [3/4]

void Botan::Buffered_Computation::update | ( | const std::string & | str | ) |
| inline inherited

Add new input to process.

Parameters

  str | the input to process as a std::string. Will be interpreted as a byte array based on the strings encoding.

Definition at line 63 of file buf_comp.h.

64 {
65 add_data(reinterpret_cast<const byte*>(str.data()), str.size());
66 }

## ◆ update() [4/4]

void Botan::Buffered_Computation::update | ( | byte | in | ) |
| inline inherited

Process a single byte.

Parameters

  in | the byte to process

Definition at line 72 of file buf_comp.h.

72 { add_data(&in, 1); }

## ◆ update_be()

template<typename T >

void Botan::Buffered_Computation::update_be | ( | const T | in | ) |
| inline inherited

Add an integer in big-endian order

Parameters

  in | the value

Definition at line 48 of file buf_comp.h.

References Botan::get_byte().

Referenced by Botan::KDF2::derive(), Botan::PKCS5_PBKDF2::derive_key(), Botan::Record_Reader::get_record(), and Botan::MGF1::mask().

49 {
50 for(size_t i = 0; i != sizeof(T); ++i)
51 {
52 byte b = get_byte(i, in);
53 add_data(&b, 1);
54 }
55 }
Botan::get_byte
byte get_byte(size_t byte_num, T input)
Definition: get_byte.h:21
Botan::byte
unsigned char byte
Definition: types.h:22

The documentation for this class was generated from the following files:

- src/hash/par_hash/par_hash.h
- src/hash/par_hash/par_hash.cpp